#include <mega8.h>
#include <delay.h>

#define KEY_UP   0b00000110 /*  6*/
#define KEY_DN   0b00000101 /*  5*/
#define KEY_NEXT 0b00000011 /*  3*/            
#define KEY_NONE 0b00000111 /*  7*/

//

volatile unsigned char temp; //   temp

// Timer2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
// Place your code here

}

// Timer2 output compare interrupt service routine
interrupt [TIM2_COMP] void timer2_comp_isr(void)
{
// Place your code here
}

// ,       
unsigned char get_key(void){
   temp = PINC;                 //    
   temp=temp&0b00000111;        /* &
                                    3 KEY_NEXT
                                   00000011
                                   00000111
                                  ---------
                                   00000011 .. temp=3*/
   delay_ms(30);      //
   return temp;
}

static void mode1(void){        //   mode1,  
        unsigned char key;
        while(get_key()!=KEY_NEXT){ //    KEY_NEXT
        key = get_key();               
        switch(key){
                case KEY_UP:
                { 
                        if(OCR2 < 255) OCR2++; //
                        break;
                }
                case KEY_DN: 
                {
                        if(OCR2) OCR2--;       //
                        break;
                }
                }
                  
        }
}

static void mode2(void){   //  mode2,  
   unsigned char key;
   static signed char reverse;
   while(1){
      key = get_key();
      if(key == KEY_NEXT)   //,  KEY_NEXT 
      {
      return;      //  
      }
      if(OCR2 == 255) reverse = -1; //  
      
      if(OCR2 == 0) reverse = 1;    // 
      OCR2 += reverse;
      delay_ms(50);
   }
}

void main(void)
{
// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=0 State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x08;
// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=P State1=P State0=P 
PORTC=0x07;
DDRC=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 125,000 kHz
// Mode: Fast PWM top=FFh
// OC2 output: Non-Inverted PWM
ASSR=0x00;
TCCR2=0x6C;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0xC0;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

while(1){
      mode1();  //   
      mode2();
       }
}
